#include <stdio.h> /* DEBUGGING */
#include "mpi.h" /* for DEBUGGING */

#include "../mas-slave.h"

#define MS_TRACE FALSE
#define MS_TRACE TRUE
#define TASK_INTERVAL 1000
#define TASK_INTERVAL 100000

#if defined(NS) && NS > -1
#define NUMSLAVES NS
#else
#define NUMSLAVES 2
#endif

long factors[1000], num_to_factor, last_num;
void MasSlaveFactor();
void trace_fmt(dest,msg) int dest; void *msg;
  {if (msg <= (void *)1) printf("%d",(int)msg); /* If 0 or 1 (error indic.) */
   else printf("%ld",*(long *)msg);}

void main(argc, argv)
int argc;
char *argv[];
{ int i;

  if ( argc == 1 ) {
    printf("Missing number arg on command line.\n");
    exit(1); }
  master_slave_trace = MS_TRACE;
  master_slave_trace_cmd = trace_fmt;
  init_master_slave(NUMSLAVES, &argc, &argv);
  MasSlaveFactor( atoi(argv[1]) );
  if (1 || is_master()) {
    for (i = 1; i <= factors[ 0 ]; i++) printf("%d ", factors[i]);
    printf("\n"); }
  /* MPI_Finalize(); */
  exit(0);
}

void *GetTask() {
  last_num = last_num + TASK_INTERVAL;
  if ( last_num > num_to_factor ) { return NOTASK; }
  return MSG(&last_num, sizeof(last_num)); }
void *DoTask( num_ptr )
void *num_ptr;
{ long limit;
  long num = *(long *)num_ptr;
  limit = num + TASK_INTERVAL;
  for ( ; num < limit; num++ )
    if (num_to_factor % num == 0) return (void *) 1;
  return (void *) 0; }
int GetTaskResult( result, num_ptr )
void *result, *num_ptr;
{ if ( (long)result == 0 /* false */ ) { return NO_ACTION; }
  if ( ! is_up_to_date() ) { return REDO; }
  return UPDATE; } 
void UpdateEnvironment( result, num_ptr )
void *result, *num_ptr;
{ long limit, num = *(long *)num_ptr;
  limit = num + TASK_INTERVAL;
  for ( ; num < limit; num++ )
    while (num_to_factor % num == 0) {
      factors[ ++factors[0] ] = num;
      num_to_factor = num_to_factor / num;
      if (num_to_factor == 1) return;
} }

void MasSlaveFactor( num )
long num;
{ factors[0]=0;
  last_num = 2 - TASK_INTERVAL;
  num_to_factor = num;
  master_slave( GetTask, DoTask, GetTaskResult, UpdateEnvironment );
}
